diff -ruN vdr-1.7.10/pat.c vdr-1.7.11/pat.c
--- vdr-1.7.10/pat.c	2009-08-16 17:01:03.000000000 +0200
+++ vdr-1.7.11/pat.c	2010-01-01 16:40:05.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: pat.c 2.4 2009/08/16 15:01:03 kls Exp $
+ * $Id: pat.c 2.7 2010/01/01 15:40:05 kls Exp $
  */
 
 #include "pat.h"
@@ -144,7 +144,7 @@
   q += sprintf(q, "CAM: %04X %5d %5d %04X %04X -", source, transponder, serviceId, d->getCaType(), EsPid);
   for (int i = 0; i < nca->Length(); i++)
       q += sprintf(q, " %02X", nca->Data()[i]);
-  dsyslog(buffer);
+  dsyslog("%s", buffer);
 #endif
 }
 
@@ -345,6 +345,7 @@
         int NumDpids = 0;
         int NumSpids = 0;
         for (SI::Loop::Iterator it; pmt.streamLoop.getNext(stream, it); ) {
+            bool ProcessCaDescriptors = false;
             int esPid = stream.getPid();
             switch (stream.getStreamType()) {
               case 1: // STREAMTYPE_11172_VIDEO
@@ -353,6 +354,7 @@
                       Vpid = esPid;
                       Ppid = pmt.getPCRPid();
                       Vtype = stream.getStreamType();
+                      ProcessCaDescriptors = true;
                       break;
               case 3: // STREAMTYPE_11172_AUDIO
               case 4: // STREAMTYPE_13818_AUDIO
@@ -385,6 +387,7 @@
                              }
                          NumApids++;
                          }
+                      ProcessCaDescriptors = true;
                       }
                       break;
               case 5: // STREAMTYPE_13818_PRIVATE
@@ -398,6 +401,7 @@
                           switch (d->getDescriptorTag()) {
                             case SI::AC3DescriptorTag:
                                  dpid = esPid;
+                                 ProcessCaDescriptors = true;
                                  break;
                             case SI::SubtitlingDescriptorTag:
                                  if (NumSpids < MAXSPIDS) {
@@ -443,12 +447,14 @@
                          }
                       }
                       break;
-              //default: printf("PID: %5d %5d %2d %3d %3d\n", pmt.getServiceId(), stream.getPid(), stream.getStreamType(), pmt.getVersionNumber(), Channel->Number());//XXX
+              default: ;//printf("PID: %5d %5d %2d %3d %3d\n", pmt.getServiceId(), stream.getPid(), stream.getStreamType(), pmt.getVersionNumber(), Channel->Number());
               }
-            for (SI::Loop::Iterator it; (d = (SI::CaDescriptor*)stream.streamDescriptors.getNext(it, SI::CaDescriptorTag)); ) {
-                CaDescriptors->AddCaDescriptor(d, esPid);
-                delete d;
-                }
+            if (ProcessCaDescriptors) {
+               for (SI::Loop::Iterator it; (d = (SI::CaDescriptor*)stream.streamDescriptors.getNext(it, SI::CaDescriptorTag)); ) {
+                   CaDescriptors->AddCaDescriptor(d, esPid);
+                   delete d;
+                   }
+               }
             }
         if (Setup.UpdateChannels >= 2) {
            Channel->SetPids(Vpid, Ppid, Vtype, Apids, ALangs, Dpids, DLangs, Spids, SLangs, Tpid);
diff -ruN vdr-1.7.10/plugin.c vdr-1.7.11/plugin.c
--- vdr-1.7.10/plugin.c	2009-04-05 12:16:48.000000000 +0200
+++ vdr-1.7.11/plugin.c	2010-01-06 12:36:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.c 2.1 2009/04/05 10:16:48 kls Exp $
+ * $Id: plugin.c 2.2 2010/01/06 11:36:46 kls Exp $
  */
 
 #include "plugin.h"
@@ -172,15 +172,15 @@
 static char *SkipQuote(char *s)
 {
   char c = *s;
-  strcpy(s, s + 1);
+  memmove(s, s + 1, strlen(s));
   while (*s && *s != c) {
         if (*s == '\\')
-           strcpy(s, s + 1);
+           memmove(s, s + 1, strlen(s));
         if (*s)
            s++;
         }
   if (*s) {
-     strcpy(s, s + 1);
+     memmove(s, s + 1, strlen(s));
      return s;
      }
   esyslog("ERROR: missing closing %c", c);
@@ -215,7 +215,7 @@
               if (!q)
                  q = p;
               switch (*p) {
-                case '\\': strcpy(p, p + 1);
+                case '\\': memmove(p, p + 1, strlen(p));
                            if (*p)
                               p++;
                            else {
diff -ruN vdr-1.7.10/receiver.c vdr-1.7.11/receiver.c
--- vdr-1.7.10/receiver.c	2007-08-12 13:52:59.000000000 +0200
+++ vdr-1.7.11/receiver.c	2010-01-01 16:38:48.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.c 2.0 2007/08/12 11:52:59 kls Exp $
+ * $Id: receiver.c 2.1 2010/01/01 15:38:48 kls Exp $
  */
 
 #include "receiver.h"
@@ -40,7 +40,7 @@
 {
   if (device) {
      const char *msg = "ERROR: cReceiver has not been detached yet! This is a design fault and VDR will segfault now!";
-     esyslog(msg);
+     esyslog("%s", msg);
      fprintf(stderr, "%s\n", msg);
      *(char *)0 = 0; // cause a segfault
      }
diff -ruN vdr-1.7.10/recorder.c vdr-1.7.11/recorder.c
--- vdr-1.7.10/recorder.c	2009-11-21 16:58:12.000000000 +0100
+++ vdr-1.7.11/recorder.c	2009-12-06 12:34:41.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.c 2.6 2009/11/21 15:58:12 kls Exp $
+ * $Id: recorder.c 2.7 2009/12/06 11:34:41 kls Exp $
  */
 
 #include "recorder.h"
@@ -128,7 +128,7 @@
               if (frameDetector->Synced()) {
                  if (!InfoWritten) {
                     if (recordingInfo.Read()) {
-                       if (frameDetector->FramesPerSecond() > 0 && recordingInfo.FramesPerSecond() != frameDetector->FramesPerSecond()) {
+                       if (frameDetector->FramesPerSecond() > 0 && !DoubleEqual(recordingInfo.FramesPerSecond(), frameDetector->FramesPerSecond())) {
                           recordingInfo.SetFramesPerSecond(frameDetector->FramesPerSecond());
                           recordingInfo.Write();
                           }
diff -ruN vdr-1.7.10/recording.c vdr-1.7.11/recording.c
--- vdr-1.7.10/recording.c	2009-11-22 12:20:53.000000000 +0100
+++ vdr-1.7.11/recording.c	2010-01-02 14:46:05.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.18 2009/11/22 11:20:53 kls Exp $
+ * $Id: recording.c 2.21 2010/01/02 13:46:05 kls Exp $
  */
 
 #include "recording.h"
@@ -260,6 +260,7 @@
                  switch (*s) {
                    case 'I': resume = atoi(t);
                              break;
+                   default: ;
                    }
                  }
            fclose(f);
@@ -443,8 +444,8 @@
                             ownEvent->SetEventID(EventID);
                             ownEvent->SetStartTime(StartTime);
                             ownEvent->SetDuration(Duration);
-                            ownEvent->SetTableID(TableID);
-                            ownEvent->SetVersion(Version);
+                            ownEvent->SetTableID(uchar(TableID));
+                            ownEvent->SetVersion(uchar(Version));
                             }
                        }
                        break;
@@ -570,7 +571,7 @@
                      if (strlen(p) > 2 && isxdigit(*(p + 1)) && isxdigit(*(p + 2))) {
                         char buf[3];
                         sprintf(buf, "%c%c", *(p + 1), *(p + 2));
-                        unsigned char c = strtol(buf, NULL, 16);
+                        uchar c = uchar(strtol(buf, NULL, 16));
                         if (c) {
                            *p = c;
                            memmove(p + 1, p + 3, strlen(p) - 2);
@@ -582,6 +583,7 @@
                 case '\x01': *p = '\''; break;
                 case '\x02': *p = '/';  break;
                 case '\x03': *p = ':';  break;
+                default: ;
                 }
               }
            }
@@ -672,7 +674,9 @@
   deleted = 0;
   titleBuffer = NULL;
   sortBuffer = NULL;
-  fileName = strdup(FileName);
+  FileName = fileName = strdup(FileName);
+  if (*(fileName + strlen(fileName) - 1) == '/')
+     *(fileName + strlen(fileName) - 1) = 0;
   FileName += strlen(VideoDirectory) + 1;
   const char *p = strrchr(FileName, '/');
 
@@ -1412,8 +1416,11 @@
         // Read data:
         else if (ReplayFile) {
            int Result = Buffer.Read(ReplayFile, BufferChunks);
-           if (Result == 0) // EOF
+           if (Result == 0) { // EOF
               ReplayFile = FileName.NextFile();
+              FileSize = 0;
+              FrameOffset = -1;
+              }
            }
         // Recording has been processed:
         else {
@@ -1498,19 +1505,19 @@
         if (access(fileName, R_OK) == 0) {
            struct stat buf;
            if (stat(fileName, &buf) == 0) {
-              delta = buf.st_size % sizeof(tIndexTs);
+              delta = int(buf.st_size % sizeof(tIndexTs));
               if (delta) {
                  delta = sizeof(tIndexTs) - delta;
                  esyslog("ERROR: invalid file size (%lld) in '%s'", buf.st_size, fileName);
                  }
-              last = (buf.st_size + delta) / sizeof(tIndexTs) - 1;
+              last = int((buf.st_size + delta) / sizeof(tIndexTs) - 1);
               if (!Record && last >= 0) {
                  size = last + 1;
                  index = MALLOC(tIndexTs, size);
                  if (index) {
                     f = open(fileName, O_RDONLY);
                     if (f >= 0) {
-                       if ((int)safe_read(f, index, buf.st_size) != buf.st_size) {
+                       if (safe_read(f, index, size_t(buf.st_size)) != buf.st_size) {
                           esyslog("ERROR: can't read from file '%s'", fileName);
                           free(index);
                           index = NULL;
@@ -1576,8 +1583,8 @@
   tIndexPes IndexPes;
   while (Count-- > 0) {
         IndexPes.offset = uint32_t(IndexTs->offset);
-        IndexPes.type = IndexTs->independent ? 1 : 2; // I_FRAME : "not I_FRAME" (exact frame type doesn't matter)
-        IndexPes.number = IndexTs->number;
+        IndexPes.type = uchar(IndexTs->independent ? 1 : 2); // I_FRAME : "not I_FRAME" (exact frame type doesn't matter)
+        IndexPes.number = uchar(IndexTs->number);
         IndexPes.reserved = 0;
         memcpy(IndexTs, &IndexPes, sizeof(*IndexTs));
         IndexTs++;
@@ -1598,7 +1605,7 @@
                f = -1;
                break;
                }
-            int newLast = buf.st_size / sizeof(tIndexTs) - 1;
+            int newLast = int(buf.st_size / sizeof(tIndexTs) - 1);
             if (newLast > last) {
                if (size <= newLast) {
                   size *= 2;
@@ -1668,7 +1675,7 @@
            uint16_t fn = index[Index + 1].number;
            off_t fo = index[Index + 1].offset;
            if (fn == *FileNumber)
-              *Length = fo - *FileOffset;
+              *Length = int(fo - *FileOffset);
            else
               *Length = -1; // this means "everything up to EOF" (the buffer's Read function will act accordingly)
            }
@@ -1699,7 +1706,7 @@
                   uint16_t fn = index[Index + 1].number;
                   off_t fo = index[Index + 1].offset;
                   if (fn == *FileNumber)
-                     *Length = fo - *FileOffset;
+                     *Length = int(fo - *FileOffset);
                   else {
                      esyslog("ERROR: 'I' frame at end of file #%d", *FileNumber);
                      *Length = -1;
@@ -1746,6 +1753,33 @@
      }
 }
 
+bool GenerateIndex(const char *FileName) 
+{
+  if (DirectoryOk(FileName)) {
+     cRecording Recording(FileName);
+     if (Recording.Name()) {
+        if (!Recording.IsPesRecording()) {
+           cString IndexFileName = AddDirectory(FileName, INDEXFILESUFFIX);
+           unlink(IndexFileName);
+           cIndexFileGenerator *IndexFileGenerator = new cIndexFileGenerator(FileName);
+           while (IndexFileGenerator->Active())
+                 cCondWait::SleepMs(INDEXFILECHECKINTERVAL);
+           if (access(IndexFileName, R_OK) == 0)
+              return true;
+           else
+              fprintf(stderr, "cannot create '%s'\n", *IndexFileName);
+           }
+        else
+           fprintf(stderr, "'%s' is not a TS recording\n", FileName);
+        }
+     else
+        fprintf(stderr, "'%s' is not a recording\n", FileName);
+     }
+  else
+     fprintf(stderr, "'%s' is not a directory\n", FileName);
+  return false;
+}
+
 // --- cFileName -------------------------------------------------------------
 
 #define MAXFILESPERRECORDINGPES 255
@@ -1868,11 +1902,11 @@
      Close();
   int MaxFilesPerRecording = isPesRecording ? MAXFILESPERRECORDINGPES : MAXFILESPERRECORDINGTS;
   if (0 < Number && Number <= MaxFilesPerRecording) {
-     fileNumber = Number;
+     fileNumber = uint16_t(Number);
      sprintf(pFileNumber, isPesRecording ? RECORDFILESUFFIXPES : RECORDFILESUFFIXTS, fileNumber);
      if (record) {
         if (access(fileName, F_OK) == 0) {
-           // files exists, check if it has non-zero size
+           // file exists, check if it has non-zero size
            struct stat buf;
            if (stat(fileName, &buf) == 0) {
               if (buf.st_size != 0)
diff -ruN vdr-1.7.10/recording.h vdr-1.7.11/recording.h
--- vdr-1.7.10/recording.h	2009-11-21 17:12:55.000000000 +0100
+++ vdr-1.7.11/recording.h	2010-01-02 13:10:07.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 2.10 2009/11/21 16:12:55 kls Exp $
+ * $Id: recording.h 2.12 2010/01/02 12:10:07 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -253,7 +253,7 @@
 class cFileName {
 private:
   cUnbufferedFile *file;
-  int fileNumber;
+  uint16_t fileNumber;
   char *fileName, *pFileNumber;
   bool record;
   bool blocking;
@@ -262,11 +262,11 @@
   cFileName(const char *FileName, bool Record, bool Blocking = false, bool IsPesRecording = false);
   ~cFileName();
   const char *Name(void) { return fileName; }
-  int Number(void) { return fileNumber; }
+  uint16_t Number(void) { return fileNumber; }
   bool GetLastPatPmtVersions(int &PatVersion, int &PmtVersion);
   cUnbufferedFile *Open(void);
   void Close(void);
-  cUnbufferedFile *SetOffset(int Number, off_t Offset = 0);
+  cUnbufferedFile *SetOffset(int Number, off_t Offset = 0); // yes, Number is int for easier internal calculating
   cUnbufferedFile *NextFile(void);
   };
 
@@ -285,4 +285,6 @@
       // be modified and may be reallocated if more space is needed. The return
       // value points to the resulting string, which may be different from s.
 
+bool GenerateIndex(const char *FileName);
+
 #endif //__RECORDING_H
diff -ruN vdr-1.7.10/remote.c vdr-1.7.11/remote.c
--- vdr-1.7.10/remote.c	2008-02-23 15:14:46.000000000 +0100
+++ vdr-1.7.11/remote.c	2009-12-06 13:08:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 2.0 2008/02/23 14:14:46 kls Exp $
+ * $Id: remote.c 2.1 2009/12/06 12:08:03 kls Exp $
  */
 
 #include "remote.h"
@@ -287,7 +287,9 @@
       if (p->code == Code)
          return p->func;
       }
-  return (Code <= 0xFF) ? Code : kfNone;
+  if (Code <= 0xFF)
+     return Code;
+  return kfNone;
 }
 
 int cKbdRemote::ReadKey(void)
@@ -337,9 +339,11 @@
                                 k |= key1 & 0xFF;
                                 } while (key1 != 0x7E);
                              break;
+                        default: ;
                         }
                       }
                    break;
+              default: ;
               }
             }
         }
diff -ruN vdr-1.7.10/remux.c vdr-1.7.11/remux.c
--- vdr-1.7.10/remux.c	2009-11-22 12:23:27.000000000 +0100
+++ vdr-1.7.11/remux.c	2009-12-29 16:56:33.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.29 2009/11/22 11:23:27 kls Exp $
+ * $Id: remux.c 2.37 2009/12/29 15:56:33 kls Exp $
  */
 
 #include "remux.h"
@@ -295,7 +295,7 @@
   numPmtPackets = 0;
   if (Channel) {
      int Vpid = Channel->Vpid();
-     int Ppid = Channel->Ppid();
+     int Ppid = 0x1FFF; // no PCR pid
      uchar *p = buf;
      int i = 0;
      p[i++] = 0x02; // table id
@@ -486,6 +486,11 @@
      int NumDpids = 0;
      int NumSpids = 0;
      vpid = vtype = 0;
+     apids[0] = 0;
+     dpids[0] = 0;
+     spids[0] = 0;
+     atypes[0] = 0;
+     dtypes[0] = 0;
      SI::PMT::Stream stream;
      for (SI::Loop::Iterator it; Pmt.streamLoop.getNext(stream, it); ) {
          dbgpatpmt("     stream type = %02X, pid = %d", stream.getStreamType(), stream.getPid());
@@ -496,17 +501,20 @@
                       vpid = stream.getPid();
                       vtype = stream.getStreamType();
                       break;
+           case 0x03: // STREAMTYPE_11172_AUDIO
            case 0x04: // STREAMTYPE_13818_AUDIO
                       {
                       if (NumApids < MAXAPIDS) {
-                         char ALangs[MAXLANGCODE2] = "";
+                         apids[NumApids] = stream.getPid();
+                         atypes[NumApids] = stream.getStreamType();
+                         *alangs[NumApids] = 0;
                          SI::Descriptor *d;
                          for (SI::Loop::Iterator it; (d = stream.streamDescriptors.getNext(it)); ) {
                              switch (d->getDescriptorTag()) {
                                case SI::ISO639LanguageDescriptorTag: {
                                     SI::ISO639LanguageDescriptor *ld = (SI::ISO639LanguageDescriptor *)d;
                                     SI::ISO639LanguageDescriptor::Language l;
-                                    char *s = ALangs;
+                                    char *s = alangs[NumApids];
                                     int n = 0;
                                     for (SI::Loop::Iterator it; ld->languageLoop.getNext(l, it); ) {
                                         if (*ld->languageCode != '-') { // some use "---" to indicate "none"
@@ -526,8 +534,9 @@
                              delete d;
                              }
                          if (updatePrimaryDevice)
-                            cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, NumApids, stream.getPid(), ALangs);
+                            cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, NumApids, apids[NumApids], alangs[NumApids]);
                          NumApids++;
+                         apids[NumApids]= 0;
                          }
                       }
                       break;
@@ -545,14 +554,21 @@
                             case SI::SubtitlingDescriptorTag:
                                  dbgpatpmt(" subtitling");
                                  if (NumSpids < MAXSPIDS) {
+                                    spids[NumSpids] = stream.getPid();
+                                    *slangs[NumSpids] = 0;
+                                    subtitlingTypes[NumSpids] = 0;
+                                    compositionPageIds[NumSpids] = 0;
+                                    ancillaryPageIds[NumSpids] = 0;
                                     SI::SubtitlingDescriptor *sd = (SI::SubtitlingDescriptor *)d;
                                     SI::SubtitlingDescriptor::Subtitling sub;
-                                    char SLangs[MAXLANGCODE2] = "";
-                                    char *s = SLangs;
+                                    char *s = slangs[NumSpids];
                                     int n = 0;
                                     for (SI::Loop::Iterator it; sd->subtitlingLoop.getNext(sub, it); ) {
                                         if (sub.languageCode[0]) {
                                            dbgpatpmt(" '%s'", sub.languageCode);
+                                           subtitlingTypes[NumSpids] = sub.getSubtitlingType();
+                                           compositionPageIds[NumSpids] = sub.getCompositionPageId();
+                                           ancillaryPageIds[NumSpids] = sub.getAncillaryPageId();
                                            if (n > 0)
                                               *s++ = '+';
                                            strn0cpy(s, I18nNormalizeLanguageCode(sub.languageCode), MAXLANGCODE1);
@@ -562,8 +578,9 @@
                                            }
                                         }
                                     if (updatePrimaryDevice)
-                                       cDevice::PrimaryDevice()->SetAvailableTrack(ttSubtitle, NumSpids, stream.getPid(), SLangs);
+                                       cDevice::PrimaryDevice()->SetAvailableTrack(ttSubtitle, NumSpids, spids[NumSpids], slangs[NumSpids]);
                                     NumSpids++;
+                                    spids[NumSpids]= 0;
                                     }
                                  break;
                             case SI::ISO639LanguageDescriptorTag: {
@@ -578,13 +595,18 @@
                           }
                       if (dpid) {
                          if (NumDpids < MAXDPIDS) {
+                            dpids[NumDpids] = dpid;
+                            dtypes[NumDpids] = stream.getStreamType();
+                            strn0cpy(dlangs[NumDpids], lang, sizeof(dlangs[NumDpids]));
                             if (updatePrimaryDevice)
                                cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, NumDpids, dpid, lang);
                             NumDpids++;
+                            dpids[NumDpids]= 0;
                             }
                          }
                       }
                       break;
+           default: ;
            }
          dbgpatpmt("\n");
          if (updatePrimaryDevice) {
@@ -599,7 +621,7 @@
   pmtSize = 0;
 }
 
-bool cPatPmtParser::GetVersions(int &PatVersion, int &PmtVersion)
+bool cPatPmtParser::GetVersions(int &PatVersion, int &PmtVersion) const
 {
   PatVersion = patVersion;
   PmtVersion = pmtVersion;
diff -ruN vdr-1.7.10/remux.h vdr-1.7.11/remux.h
--- vdr-1.7.10/remux.h	2009-11-21 16:55:34.000000000 +0100
+++ vdr-1.7.11/remux.h	2009-12-29 16:53:54.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.h 2.20 2009/11/21 15:55:34 kls Exp $
+ * $Id: remux.h 2.23 2009/12/29 15:53:54 kls Exp $
  */
 
 #ifndef __REMUX_H
@@ -214,6 +214,17 @@
   int pmtPid;
   int vpid;
   int vtype;
+  int apids[MAXAPIDS + 1]; // list is zero-terminated
+  int atypes[MAXAPIDS + 1]; // list is zero-terminated
+  char alangs[MAXAPIDS][MAXLANGCODE2];
+  int dpids[MAXDPIDS + 1]; // list is zero-terminated
+  int dtypes[MAXDPIDS + 1]; // list is zero-terminated
+  char dlangs[MAXDPIDS][MAXLANGCODE2];
+  int spids[MAXSPIDS + 1]; // list is zero-terminated
+  char slangs[MAXSPIDS][MAXLANGCODE2];
+  uchar subtitlingTypes[MAXSPIDS];
+  uint16_t compositionPageIds[MAXSPIDS];
+  uint16_t ancillaryPageIds[MAXSPIDS];
   bool updatePrimaryDevice;
 protected:
   int SectionLength(const uchar *Data, int Length) { return (Length >= 3) ? ((int(Data[1]) & 0x0F) << 8)| Data[2] : 0; }
@@ -232,18 +243,32 @@
        ///< are delivered to the parser through several subsequent calls to
        ///< ParsePmt(). The whole PMT data will be processed once the last packet
        ///< has been received.
-  bool GetVersions(int &PatVersion, int &PmtVersion);
+  bool GetVersions(int &PatVersion, int &PmtVersion) const;
        ///< Returns true if a valid PAT/PMT has been parsed and stores
        ///< the current version numbers in the given variables.
-  int PmtPid(void) { return pmtPid; }
+  int PmtPid(void) const { return pmtPid; }
        ///< Returns the PMT pid as defined by the current PAT.
        ///< If no PAT has been received yet, -1 will be returned.
-  int Vpid(void) { return vpid; }
+  int Vpid(void) const { return vpid; }
        ///< Returns the video pid as defined by the current PMT, or 0 if no video
        ///< pid has been detected, yet.
-  int Vtype(void) { return vtype; }
+  int Vtype(void) const { return vtype; }
        ///< Returns the video stream type as defined by the current PMT, or 0 if no video
        ///< stream type has been detected, yet.
+  const int *Apids(void) const { return apids; }
+  const int *Dpids(void) const { return dpids; }
+  const int *Spids(void) const { return spids; }
+  int Apid(int i) const { return (0 <= i && i < MAXAPIDS) ? apids[i] : 0; }
+  int Dpid(int i) const { return (0 <= i && i < MAXDPIDS) ? dpids[i] : 0; }
+  int Spid(int i) const { return (0 <= i && i < MAXSPIDS) ? spids[i] : 0; }
+  int Atype(int i) const { return (0 <= i && i < MAXAPIDS) ? atypes[i] : 0; }
+  int Dtype(int i) const { return (0 <= i && i < MAXDPIDS) ? dtypes[i] : 0; }
+  const char *Alang(int i) const { return (0 <= i && i < MAXAPIDS) ? alangs[i] : ""; }
+  const char *Dlang(int i) const { return (0 <= i && i < MAXDPIDS) ? dlangs[i] : ""; }
+  const char *Slang(int i) const { return (0 <= i && i < MAXSPIDS) ? slangs[i] : ""; }
+  uchar SubtitlingType(int i) const { return (0 <= i && i < MAXSPIDS) ? subtitlingTypes[i] : uchar(0); }
+  uint16_t CompositionPageId(int i) const { return (0 <= i && i < MAXSPIDS) ? compositionPageIds[i] : uint16_t(0); }
+  uint16_t AncillaryPageId(int i) const { return (0 <= i && i < MAXSPIDS) ? ancillaryPageIds[i] : uint16_t(0); }
   };
 
 // TS to PES converter:
diff -ruN vdr-1.7.10/sdt.c vdr-1.7.11/sdt.c
--- vdr-1.7.10/sdt.c	2008-04-12 15:33:55.000000000 +0200
+++ vdr-1.7.11/sdt.c	2009-12-23 17:02:47.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sdt.c 2.1 2008/04/12 13:33:55 kls Exp $
+ * $Id: sdt.c 2.4 2009/12/23 16:02:47 kls Exp $
  */
 
 #include "sdt.h"
@@ -65,16 +65,18 @@
                         char *ps = compactspace(ShortNameBuf);
                         if (!*ps && cSource::IsCable(Source())) {
                            // Some cable providers don't mark short channel names according to the
-                           // standard, but rather go their own way and use "name>short name" or
-                           // "name, short name":
+                           // standard, but rather go their own way and use "name>short name":
                            char *p = strchr(pn, '>'); // fix for UPC Wien
-                           if (!p)
-                              p = strchr(pn, ','); // fix for "Kabel Deutschland"
                            if (p && p > pn) {
                               *p++ = 0;
                               strcpy(ShortNameBuf, skipspace(p));
                               }
                            }
+                        // Avoid ',' in short name (would cause trouble in channels.conf):
+                        for (char *p = ShortNameBuf; *p; p++) {
+                            if (*p == ',')
+                               *p = '.';
+                            }
                         sd->providerName.getText(ProviderNameBuf, sizeof(ProviderNameBuf));
                         char *pp = compactspace(ProviderNameBuf);
                         if (channel) {
@@ -92,6 +94,7 @@
                            patFilter->Trigger();
                            }
                         }
+                   default: ;
                    }
                  }
                  break;
diff -ruN vdr-1.7.10/skinclassic.c vdr-1.7.11/skinclassic.c
--- vdr-1.7.10/skinclassic.c	2008-02-23 11:31:58.000000000 +0100
+++ vdr-1.7.11/skinclassic.c	2010-01-03 15:55:10.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 2.0 2008/02/23 10:31:58 kls Exp $
+ * $Id: skinclassic.c 2.3 2010/01/03 14:55:10 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -345,6 +345,12 @@
      osd->DrawText(x3 - w, y, buffer, Theme.Color(clrMenuEventVpsFg), Theme.Color(clrMenuEventVpsBg), font, w);
      }
   y += ts.Height();
+  if (Event->ParentalRating()) {
+     cString buffer = cString::sprintf(" %s ", *Event->GetParentalRatingString());
+     const cFont *font = cFont::GetFont(fontSml);
+     int w = font->Width(buffer);
+     osd->DrawText(x3 - w, y, buffer, Theme.Color(clrMenuEventVpsFg), Theme.Color(clrMenuEventVpsBg), font, w);
+     }
   y += font->Height();
   ts.Set(osd, x1, y, x2 - x1, y3 - y, Event->Title(), font, Theme.Color(clrMenuEventTitle), Theme.Color(clrBackground));
   y += ts.Height();
@@ -353,6 +359,14 @@
      ts.Set(osd, x1, y, x2 - x1, y3 - y, Event->ShortText(), font, Theme.Color(clrMenuEventShortText), Theme.Color(clrBackground));
      y += ts.Height();
      }
+  for (int i = 0; Event->Contents(i); i++) {
+      const char *s = Event->ContentToString(Event->Contents(i));
+      if (!isempty(s)) {
+         const cFont *font = cFont::GetFont(fontSml);
+         ts.Set(osd, x1, y, x2 - x1, y3 - y, s, font, Theme.Color(clrMenuEventShortText), Theme.Color(clrBackground));
+         y += ts.Height();
+         }
+      }
   y += font->Height();
   if (!isempty(Event->Description())) {
      textScroller.Set(osd, x1, y, x2 - x1, y3 - y, Event->Description(), font, Theme.Color(clrMenuEventDescription), Theme.Color(clrBackground));
@@ -372,6 +386,12 @@
   snprintf(t, sizeof(t), "%s  %s", *DateString(Recording->start), *TimeString(Recording->start));
   ts.Set(osd, x1, y, x2 - x1, y3 - y, t, font, Theme.Color(clrMenuEventTime), Theme.Color(clrBackground));
   y += ts.Height();
+  if (Info->GetEvent()->ParentalRating()) {
+     cString buffer = cString::sprintf(" %s ", *Info->GetEvent()->GetParentalRatingString());
+     const cFont *font = cFont::GetFont(fontSml);
+     int w = font->Width(buffer);
+     osd->DrawText(x3 - w, y, buffer, Theme.Color(clrMenuEventVpsFg), Theme.Color(clrMenuEventVpsBg), font, w);
+     }
   y += font->Height();
   const char *Title = Info->Title();
   if (isempty(Title))
@@ -383,6 +403,14 @@
      ts.Set(osd, x1, y, x2 - x1, y3 - y, Info->ShortText(), font, Theme.Color(clrMenuEventShortText), Theme.Color(clrBackground));
      y += ts.Height();
      }
+  for (int i = 0; Info->GetEvent()->Contents(i); i++) {
+      const char *s = Info->GetEvent()->ContentToString(Info->GetEvent()->Contents(i));
+      if (!isempty(s)) {
+         const cFont *font = cFont::GetFont(fontSml);
+         ts.Set(osd, x1, y, x2 - x1, y3 - y, s, font, Theme.Color(clrMenuEventShortText), Theme.Color(clrBackground));
+         y += ts.Height();
+         }
+      }
   y += font->Height();
   if (!isempty(Info->Description())) {
      textScroller.Set(osd, x1, y, x2 - x1, y3 - y, Info->Description(), font, Theme.Color(clrMenuEventDescription), Theme.Color(clrBackground));
